/* Reasonable way of saving which IPs are allowed to use smtp.
 * This is run between the checkpasswd element and qmail-pop3d.
 * uses a data file /var/qmail/smtpallow.dat
 * which must be group-read-writeable for qmail
*/

#include "smtpallow.h"

int main(int argc, char **argv, char *envp[])
{
 char *p;
 if (argc < 2) {
  syslog(LOG_AUTH | LOG_WARNING, "smtpallow_check: not enough parameters");
  _exit(2);
 }

 if ((p=getenv("TCPREMOTEIP"))!=0) {
  FILE *pallowfile;
  char ip[IPBUFLEN];
  strncpy(ip,p,IPBUFLEN-1);
  ip[IPBUFLEN-1]=0;
  pallowfile=fopen(SMTPALLOW_DATA,"r");
  if (pallowfile) {
   char nameandip[LARGERBUFLEN];
   nameandip[LARGERBUFLEN-1]=0;
   while (fread(nameandip,NAMEBUFLEN,1,pallowfile)) {
    if (!fread(nameandip,IPBUFLEN,1,pallowfile)) break;
    if (strncmp(ip,nameandip,IPBUFLEN)==0) {
     setenv("RELAYCLIENT","",1);
     break;
    }
   }
   fclose(pallowfile);
  } else {
   syslog(LOG_AUTH | LOG_WARNING, "smtpallow_check: couldn't open %s read",SMTPALLOW_DATA);
  }
 }
 execvp(argv[1],argv+1);
 syslog(LOG_AUTH | LOG_WARNING, "smtpallow_check: couldn't execute %s",argv[1]);
 _exit(111);
 return 0;
}

