/* Reasonable way of saving which IPs are allowed to use smtp.
 * This is run between the checkpasswd element and qmail-pop3d.
 * uses a data file /var/qmail/smtpallow.dat
 * which must be group-read-writeable for qmail
*/

#include "smtpallow.h"

int main(int argc, char **argv, char *envp[])
{
 char *p;
 if (argc < 2) {
  syslog(LOG_AUTH | LOG_WARNING, "smtpallow_save: not enough parameters");
  _exit(2);
 }

 if ((p=getenv("VIRTUALUSER"))!=0 || (p=getenv("USER"))!=0) {
  char name[NAMEBUFLEN];
  strncpy(name,p,NAMEBUFLEN-1);
  name[NAMEBUFLEN-1]=0;
  if ((p=getenv("TCPREMOTEIP"))!=0) {
   FILE *pallowfile;
   char ip[IPBUFLEN];
   strncpy(ip,p,IPBUFLEN-1);
   ip[IPBUFLEN-1]=0;
   pallowfile=fopen(SMTPALLOW_DATA,"r+");
   if (pallowfile) {
    int pos;
    char nameandip[LARGERBUFLEN];
    nameandip[LARGERBUFLEN-1]=0;
    while (fread(nameandip,NAMEBUFLEN,1,pallowfile)) {
     if (strncmp(nameandip,name,NAMEBUFLEN)==0) break;
     if (!fread(nameandip,IPBUFLEN,1,pallowfile)) break;
    }
    pos=ftell(pallowfile);
    pos-=pos%(NAMEBUFLEN+IPBUFLEN);
    fseek(pallowfile,pos,SEEK_SET);
    fwrite(name,NAMEBUFLEN,1,pallowfile);
    fwrite(ip,IPBUFLEN,1,pallowfile);
    fclose(pallowfile);
   } else {
    syslog(LOG_AUTH | LOG_WARNING, "smtpallow_save: couldn't open %s read/write",SMTPALLOW_DATA);
   }
  }
 }
#ifndef DONTUSEQMAILGROUP
 {
  struct passwd *user=getpwuid(getuid());
  if (user) {
   if (setgid(user->pw_gid)==-1) {
    syslog(LOG_AUTH | LOG_WARNING, "smtpallow_save: couldn't set group for user %s (non-fatal)",user->pw_name);
   }
  } else {
   syslog(LOG_AUTH | LOG_WARNING, "smtpallow_save: couldn't retrieve group for user (non-fatal)");
  }
 }
#endif
 execvp(argv[1],argv+1);
 syslog(LOG_AUTH | LOG_WARNING, "smtpallow_save: couldn't execute %s",argv[1]);
 _exit(111);
 return 0;
}

